import QtQuick 1.1
import com.nokia.meego 1.1
import com.nokia.extras 1.1
import 'StatDSN.js' as StatDSN

Page {
    id: fixItPageId
    anchors.fill: parent
    property string theIpAddress: '';
    Component.onCompleted: {
        //console.log(">>>>>>>>>>>>>>"+fixItPageId.status)
        fixIt.active = false
        home.active = true
        home.visible = true
        fixIt.visible = false
    }

    tools: commonTools

    Rectangle {
        id: rectangle1
        color: "#000000"
        anchors.fill: parent
    }

    Sheet {
        id: sheetCustomCOnf
        anchors.fill: parent

        rejectButtonText: qsTr("Cancel")
        content: Flickable {
            anchors.fill: parent
            anchors.leftMargin: 8
            anchors.topMargin: 8
            contentHeight: col2.height
            flickableDirection: Flickable.VerticalFlick
            Column{
                spacing: 10
                Text {
                    id: theLabelOfIp
                    text: qsTr("Input custom IP")
                    font.pixelSize: 20
                }

                Rectangle {
                    height: 3
                    width: 460
                    color: "#56c5eb"
                    anchors.rightMargin: 10
                    anchors.leftMargin: 10
                    anchors.horizontalCenter: parent.horizontalCenter
                }

                Grid {
                    columns: 7
                    spacing: 2
                    id: col2
                    TextField {
                        id : iprang1
                        placeholderText: '192'
                        width: (fixItPageId.width-60)/4
                        //inputMask: '999'
                        maximumLength: 3
                        inputMethodHints: Qt.ImhDigitsOnly
                        validator: RegExpValidator { regExp: /^([01]?[0-9]?[0-9]|2[0-4][0-9]|25[0-5])$/ }
                        Keys.onReturnPressed: {
                           // platformCloseSoftwareInputPanel()
                            iprang2.focus = true
                        }

                    }
                    Text {
                        text: "."
                        font.bold: true
                    }
                    TextField {
                        id : iprang2
                        placeholderText: '168'
                        width: (fixItPageId.width-60)/4
                        //inputMask: '999'
                        maximumLength: 3
                        inputMethodHints: Qt.ImhDigitsOnly
                        validator: RegExpValidator { regExp: /^([01]?[0-9]?[0-9]|2[0-4][0-9]|25[0-5])$/ }
                        Keys.onReturnPressed: {
                           // platformCloseSoftwareInputPanel()
                            iprang3.focus = true
                        }
                    }
                    Text {
                        text: "."
                        font.bold: true
                    }
                    TextField {
                        id : iprang3
                        placeholderText: '77'
                        width: (fixItPageId.width-60)/4
                        //inputMask: '999'
                        maximumLength: 3
                        inputMethodHints: Qt.ImhDigitsOnly
                        validator: RegExpValidator { regExp: /^([01]?[0-9]?[0-9]|2[0-4][0-9]|25[0-5])$/ }
                        Keys.onReturnPressed: {
                           // platformCloseSoftwareInputPanel()
                            iprang4.focus = true
                        }
                    }
                    Text {
                        text: "."
                        font.bold: true
                    }
                    TextField {
                        id : iprang4
                        placeholderText: '20'
                        width: (fixItPageId.width-60)/4
                        //inputMask: '999'
                        maximumLength: 3
                        inputMethodHints: Qt.ImhDigitsOnly
                        validator: RegExpValidator { regExp: /^([01]?[0-9]?[0-9]|2[0-4][0-9]|25[0-5])$/ }
                        Keys.onReturnPressed: {
                           // platformCloseSoftwareInputPanel()
                            applyCustomIP.focus = true
                        }
                    }
                }

                Button{
                    id: applyCustomIP
                    anchors.horizontalCenter: parent.horizontalCenter
                    height: 70
                    text: qsTr("Use this configuration")
                    width: 460
                    onClicked: {
                        advancedFixItBtn.opacity = 0.3
                        defaultFixItBtn.opacity = 0.3
                        if (iprang4.acceptableInput == true && iprang3.acceptableInput == true && iprang2.acceptableInput == true && iprang1.acceptableInput == true){
                            reloadHosts()
                            if(isConfigured){
                                banner1.text = qsTr('Please remove the old configuration before use this one...');
                                banner1.show();
                            }else{
                                banner1.text = qsTr('We will use ' + iprang1.text + '.' + iprang2.text + '.' + iprang3.text + '.' + iprang4.text + '.' + ' for the configuration');
                                banner1.show();
                                progressbar1.visible = true
                                progressbar2.visible = true
                                sheetCustomCOnf.close()
                                myFile.write(iprang1.text + '.' + iprang2.text + '.' + iprang3.text + '.' + iprang4.text)
                            }
                            progressbar1.visible = false
                            progressbar2.visible = false
                            banner2.text = qsTr("The configuration was apply with succes");
                            banner2.show();
                            iprang1.text = iprang2.text =iprang3.text =iprang4.text = ''
                            reloadHosts();
                            advancedFixItBtn.opacity = 1
                            defaultFixItBtn.opacity = 1
                        }else{
                            banner1.text = qsTr('Enter Valid IP address. Enter something like 11.123.243.179');
                            banner1.show();
                        }
                    }
                }

                Rectangle {
                    height: 90
                    width: 460
                    color: "#00000000"
                    anchors.rightMargin: 10
                    anchors.leftMargin: 10
                    anchors.horizontalCenter: parent.horizontalCenter
                }

                Text {
                    text: qsTr("Use another domain ip")
                    font.pixelSize: 20
                }

                Rectangle {
                    height: 3
                    width: 460
                    color: "#56c5eb"
                    anchors.rightMargin: 10
                    anchors.leftMargin: 10
                    anchors.horizontalCenter: parent.horizontalCenter
                }

                TextField {
                    id : domainNameResolv
                    placeholderText: 'duckduckgo.com'
                    width: 460
                    anchors.rightMargin: 10
                    anchors.leftMargin: 10
                    anchors.horizontalCenter: parent.horizontalCenter
                    validator: RegExpValidator { regExp: /^[a-zA-Z0-9][a-zA-Z0-9-]{1,61}[a-zA-Z0-9](?:\.[a-zA-Z]{2,})+$/ }
                    Keys.onReturnPressed: {
                       // platformCloseSoftwareInputPanel()
                        applyCustomDomainNameResolv.focus = true
                    }
                }
                Button{
                    id: applyCustomDomainNameResolv
                    anchors.horizontalCenter: parent.horizontalCenter
                    height: 70
                    text: qsTr("Apply this configuration")
                    width: 460
                    onClicked: {
                        if(domainNameResolv.text != ''){
                            advancedFixItBtn.opacity = 0.3
                            defaultFixItBtn.opacity = 0.3
                            if (/^[a-zA-Z0-9][a-zA-Z0-9-]{1,61}[a-zA-Z0-9](?:\.[a-zA-Z]{2,})+$/.test(domainNameResolv.text)){
                                reloadHosts()
                                if(isConfigured){
                                    banner1.text = qsTr('Please remove the old configuration before use this one...');
                                    banner1.show();
                                }else{
                                    banner1.text = qsTr('We will use ' + domainNameResolv.text + ' for the configuration');
                                    banner1.show();
                                    progressbar1.visible = true
                                    progressbar2.visible = true
                                    sheetCustomCOnf.close()
                                    StatDSN.getHostAddress(domainNameResolv.text);
                                }
                                reloadHosts();
                                domainNameResolv.text = ''
                            }else{
                                banner1.text = qsTr('Enter Valid Domain Name. Enter something like google.com');
                                banner1.show();
                            }

                            advancedFixItBtn.opacity = 1
                            defaultFixItBtn.opacity = 1
                        }else{
                            banner1.text = qsTr('You cannot use an empty domain. Enter something like google.com');
                            banner1.show();
                        }
                    }
                }
            }

            InfoBanner{
                id: banner1
                objectName: "infoBanner1Object"
                text: "..."
                anchors.top: parent.top
                anchors.topMargin: 30
            }



        }
        onAccepted: {
            progressbar2.visible=true
            defaultFixItBtn.text = qsTr("Remove the fix")
            advancedFixItBtn.enabled = false
        }
        onRejected: {
            progressbar2.visible=false
        }
    }


    //////////////////////////////////////////////////////////////////////////
    //Main view
    //////////////////////////////////////////////////////////////////////////
    Flickable {
        id: flickableCONTENT
        anchors.fill: parent

        Button {
            id: defaultFixItBtn
            height: 70
            anchors.rightMargin: 20
            anchors.leftMargin: 20
            anchors.left: parent.left
            anchors.right: parent.right
            text: (isConfigured)? qsTr("Remove the fix") : qsTr("Apply fix with default value");
            anchors.bottom: rectangle2.top
            anchors.bottomMargin: (rectangle2.y/2)-defaultFixItBtn.height
            onClicked: {
                advancedFixItBtn.opacity = 0.3
                defaultFixItBtn.opacity = 0.3
                progressbar1.visible = true
                progressbar2.visible = true
                if(isConfigured){
                    myFile.deleteConfig();
                    reloadHosts();
                    if(isConfigured){
                        banner2.text = qsTr("The configuration still exist... hum... Something is wrong");
                    }else{
                        banner2.text = qsTr("The configuration was removed !");
                    }
                    banner2.show();
                    progressbar1.visible = false
                    progressbar2.visible = false
                }else{
                    StatDSN.getHostAddress("google.com");
                }
                advancedFixItBtn.opacity = 1
                defaultFixItBtn.opacity = 1
            }
        }

        ProgressBar {
            id: progressbar1
            height: 10
            anchors.right: parent.right
            anchors.rightMargin: 20
            anchors.left: parent.left
            anchors.leftMargin: 20
            anchors.top: defaultFixItBtn.bottom
            anchors.topMargin: 20
            indeterminate: true
            visible: false
        }

        Rectangle {
            id: rectangle2
            x: 180
            y: 247
            width: 480
            height: 1
            color: "#1798c4"
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.verticalCenter: parent.verticalCenter
        }

        Button {
            id: advancedFixItBtn
            height: 70
            anchors.rightMargin: 20
            anchors.leftMargin: 20
            anchors.topMargin: (rectangle2.y/2)-advancedFixItBtn.height
            anchors.left: parent.left
            anchors.top: rectangle2.bottom
            anchors.right: parent.right
            text: qsTr("Apply fix with custom value");
            enabled: (isConfigured)? false : true;
            onClicked: sheetCustomCOnf.open()
        }

        ProgressBar {
            id: progressbar2
            height: 10
            anchors.right: parent.right
            anchors.rightMargin: 20
            anchors.left: parent.left
            anchors.leftMargin: 20
            anchors.top: advancedFixItBtn.bottom
            anchors.topMargin: 20
            indeterminate: true
            visible: false
        }

    }

    //////////////////////////////////////////////////////////////////////////
    //Top Header
    //////////////////////////////////////////////////////////////////////////
    Rectangle {
        visible: true
        id: theHeader
        //property alias title: logoText.text
        //property alias titleColor: logoText.color

        width: parent ? parent.width : 480
        height: 72
        gradient: Gradient {
            GradientStop {
                position: 0
                color: "#56c5eb"
            }

            GradientStop {
                position: 1
                color: "#1798c4"
            }
        }
        anchors.top: parent.top

        Image {
            id: logo
            x: 10
            width: 60
            height: 60
            sourceSize.height: 80
            sourceSize.width: 80
            anchors.verticalCenter: parent.verticalCenter
            source: "pics/icon.png"
            opacity: 0.0

            NumberAnimation on opacity {
                id: createAnimation
                from: 0
                to: 1
                duration: 2000
            }
            Component.onCompleted: createAnimation.start()


        }
    }


    InfoBanner{
        id: banner2
        text: "..."
        anchors.top: theHeader.top
        anchors.topMargin: 10
    }

}
