import QtQuick 1.1
import com.nokia.meego 1.1
import com.nokia.extras 1.1

Page {
    id: mainPageId
    anchors.fill: parent
    Component.onCompleted: {
        //console.log(">>>>>>>>>>>>>>"+params.mobile)
        fixIt.active = true
        home.active = false
        home.visible = false
        fixIt.visible = true
    }
    transitions: Transition {
        PropertyAnimation { property: "opacity"; to: 1.0; duration: 800 }
    }
    //anchors.margins: UiConstants.DefaultMargin
    tools: commonTools

    Rectangle {
        id: rectangle1
        color: "#000000"
        anchors.top: theHeader.bottom
        anchors.right: parent.right
        anchors.bottom: parent.bottom
        anchors.left: parent.left
        anchors.topMargin: 0
    }

    Flickable {
        id: flickZn
        anchors.right: parent.right
        anchors.left: parent.left
        anchors.top: theHeader.bottom
        width: parent.width
        anchors.bottom: parent.bottom
        anchors.topMargin: 0
        contentHeight: text1.paintedHeight + text2.paintedHeight + text3.paintedHeight + text4.paintedHeight + text5.paintedHeight + text6.paintedHeight + text7.paintedHeight + rectangle2.height + rectangle4.height + rectangle5.height + flickable1.contentHeight +flickable1.anchors.topMargin + 180
        flickableDirection: Flickable.VerticalFlick

        Text {
            id: text1
            color: "#56c5eb"
            text: qsTr("<h1>About this app.</h1>")
            font.pixelSize: 22
            horizontalAlignment: Text.AlignHCenter
            style: Text.Normal
            font.bold: true
            verticalAlignment: Text.AlignTop
            wrapMode: Text.WordWrap
            anchors.right: parent.right
            anchors.rightMargin: 10
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.top: parent.top
            anchors.topMargin: 10
        }

        Rectangle {
            id: rectangle2
            height: 2
            color: "#56c5eb"
            anchors.rightMargin: 20
            anchors.leftMargin: 20
            anchors.top: text1.bottom
            anchors.topMargin: 3
            anchors.right: parent.right
            anchors.left: parent.left
        }

        Text {
            id: text2
            color: "#ffffff"
            text: qsTr("This application provide a simple patch for the native twitter apps in MeeGo harmattan.<br /><br />It allow user to authenticate by providing a fake callback response to allow app to use twitter.<br /><br />By sign-in with the App, according to twitter workflow, you need to provide an <b>oauth_callback</b>")
            font.pixelSize: 18
            font.bold: false
            wrapMode: Text.WordWrap
            anchors.top: text1.bottom
            anchors.topMargin: 24
            anchors.right: parent.right
            anchors.rightMargin: 10
            anchors.left: parent.left
            anchors.leftMargin: 10
        }

        Flickable {
            id: flickable1
            width: 480
            height: 286
            boundsBehavior: Flickable.DragAndOvershootBounds
            contentHeight: 286
            contentWidth: 584
            flickableDirection: Flickable.HorizontalFlick
            anchors.left: parent.left
            anchors.topMargin: 48
            anchors.top: text2.bottom

            Rectangle {
                id: rectangle3
                color: "#56c5eb"
                anchors.fill: parent
            }

            Image {
                id: image1
                anchors.topMargin: 0
                anchors.fill: parent
                sourceSize.height: 286
                sourceSize.width: 584
                fillMode: Image.Tile
                source: "pics/sign-in-oauth-1_0.png"

                Image {
                    id: image2
                    width: 69
                    height: 67
                    x : 210
                    sourceSize.height: 100
                    sourceSize.width: 100
                    anchors.left: parent.left
                    anchors.leftMargin: 210
                    anchors.top: parent.top
                    anchors.topMargin: 10
                    fillMode: Image.PreserveAspectCrop
                    source: "pics/Swipe_Left.png"
                    NumberAnimation { id: swipe_LeftAnimationFade;  target: image2; property: "opacity";    duration: 3000; easing.type: Easing.InOutQuint;     loops: 5; from : 1;  to : 0}
                    Component.onCompleted: swipe_LeftAnimationFade.start()
                }
            }

        }

        Text {
            id: text3
            x: 10
            y: 416
            color: "#ffffff"
            text: qsTr("Patch only for tested on MeeGo 1.2 Harmattan PR.1.3<br />This might work in other version of MeeGo Harmatan.")
            font.pixelSize: 14
            font.italic: true
            horizontalAlignment: Text.AlignHCenter
            anchors.rightMargin: 10
            anchors.right: parent.right
            anchors.leftMargin: 10
            anchors.left: parent.left
            anchors.top: flickable1.bottom
            anchors.topMargin: 24
            wrapMode: Text.WordWrap
        }

        Text {
            id: text4
            x: 10
            y: 451
            color: "#56c5eb"
            text: qsTr("<h1>How It's Work.</h1>")
            font.pixelSize: 22
            horizontalAlignment: Text.AlignHCenter
            style: Text.Normal
            font.bold: true
            verticalAlignment: Text.AlignTop
            wrapMode: Text.WordWrap
            anchors.right: parent.right
            anchors.rightMargin: 10
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.top: text3.bottom
            anchors.topMargin: 24
        }

        Rectangle {
            id: rectangle4
            x: 10
            y: 476
            height: 2
            color: "#56c5eb"
            anchors.rightMargin: 10
            anchors.leftMargin: 10
            anchors.top: text4.bottom
            anchors.topMargin: 0
            anchors.right: parent.right
            anchors.left: parent.left
        }

        Text {
            id: text5
            x: 10
            y: 491
            color: "#ffffff"
            text: qsTr("\
<ul>\
<li>Push the button <img src='pics/fixbtn.png'/> to access fix page</li>\
<li>Push button \"Apply fix with default value\" to use default value. ! You need an internet access</li>\
<li>For advance user, you can provide a custom IP address or domain name, push apply fix wit it</li>\
<li>After Authenticate in twitter, push remove fix to restore default configuration</li>\
<ul>")
font.pixelSize: 18
            anchors.topMargin: 24
            font.bold: false
            wrapMode: Text.WordWrap
            anchors.top: text4.bottom
            anchors.right: parent.right
            anchors.rightMargin: 10
            anchors.left: parent.left
            anchors.leftMargin: 10
        }



        Text {
            id: text6
            x: 10
            y: 451
            color: "#56c5eb"
            text: qsTr("<h1>Known bugs</h1>")
            font.pixelSize: 22
            horizontalAlignment: Text.AlignHCenter
            style: Text.Normal
            font.bold: true
            verticalAlignment: Text.AlignTop
            wrapMode: Text.WordWrap
            anchors.right: parent.right
            anchors.rightMargin: 10
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.top: text5.bottom
            anchors.topMargin: 24
        }

        Rectangle {
            id: rectangle5
            x: 10
            y: 476
            height: 2
            color: "#56c5eb"
            anchors.rightMargin: 10
            anchors.leftMargin: 10
            anchors.top: text6.bottom
            anchors.topMargin: 0
            anchors.right: parent.right
            anchors.left: parent.left
        }

        Text {
            id: text7
            x: 10
            y: 491
            color: "#ffffff"
            text: qsTr("After authenticate, you might no more see profile picture due to twitter last API update. Native application cannot correctly parse data from twitter and is not able to download them.<br/>We cannot fix it because we do not have sources of this app")
            font.pixelSize: 18
            anchors.topMargin: 24
            font.bold: false
            wrapMode: Text.WordWrap
            anchors.top: text6.bottom
            anchors.right: parent.right
            anchors.rightMargin: 10
            anchors.left: parent.left
            anchors.leftMargin: 10
        }










    }

    Rectangle {
        visible: true
        id: theHeader
        property alias title: logoText.text
        property alias titleColor: logoText.color
        x: 0
        y: 0

        width: parent ? parent.width : 480
        height: 72
        gradient: Gradient {
            GradientStop {
                position: 0
                color: "#56c5eb"
            }

            GradientStop {
                position: 1
                color: "#1798c4"
            }
        }
        anchors.topMargin: 0
        anchors.top: parent.top

        Image {
            id: logo
            x: 10
            width: 60
            height: 60
            sourceSize.height: 80
            sourceSize.width: 80
            anchors.verticalCenter: parent.verticalCenter
            source: "pics/icon.png"

            Text {
                id: logoText
                anchors.verticalCenter: parent.verticalCenter
                anchors.left: logo.right
                color: "white"
                font.pixelSize: 32
                text: "TwittFix"
                anchors.leftMargin: 10
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
                font.bold: true
            }
        }

        /*ToolIcon {
            id: filterImage
            anchors.right: parent.right
            anchors.verticalCenter: parent.verticalCenter
            platformIconId: "icon-m-textinput-combobox-arrow"
        }

        MouseArea {
            id: audodMenu
            x: 0
            y: 0
            anchors.rightMargin: 0
            anchors.bottomMargin: 0
            anchors.leftMargin: 0
            anchors.topMargin: 0
            anchors.fill: theHeader
            onClicked: { headerSelectionDialog.open() }
            onPressed: { theHeader.opacity = 0.5 }
            onReleased: { theHeader.opacity = 1 }
        }
        SelectionDialog {
            id: headerSelectionDialog
            z: 95
            titleText: "Options"
            selectedIndex: 0
            model: ListModel {
                ListElement {name:"Mon profil"}
                ListElement {name:"Mes cours"}
                ListElement {name:"Mes evaluations"}
                ListElement {name:"Modifier mon compte"}
                ListElement {name:"Contacter Autodrive"}
            }
            onAccepted: {
                switch(selectedIndex){
                    case(0):
                        openFile('ProfilPage.qml')
                        break;
                    case(1):
                        openFile('MesCours.qml')
                        break;
                    case(2):
                        sheeteval.open()
                        break;
                    case(3):
                        pageStack.push(Qt.createComponent('ChangeUserInfos.qml'))
                        break;
                    case(4):
                        sheet.open()
                        break;
                    default:
                        break;
                    }
                //console.log(selectedIndex);
                //console.log(headerSelectionDialog.model.get(selectedIndex).name);
            }
        }*/
    }
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    //ScrollDecorator {
        //flickableItem: parent




    ScrollDecorator {
        flickableItem: flickZn
    }

}
