/**
 * My method description.  Like other pieces of your comment blocks,
 * this can span multiple lines.
 *
 * @method methodName
 * @param {String} foo Argument 1
 * @param {Object} config A config object
 * @param {String} config.name The name on the config object
 * @param {Function} config.callback A callback function on the config object
 * @param {Boolean} [extra=false] Do extra, optional work
 * @return {Boolean} Returns true on success
 */
function getHostAddress(hostname) {
    // Check if we o not give empty value
    if (hostname === undefined || hostname === null || hostname === '') {
        console.debug("Hostname is empty")
        theIpAddress = 'false';
    }else{

        // the URL for the Query
        var uri = "http://api.statdns.com/"+hostname+"/a";

        //call function to execute XHR Query
        request(uri, function (res) {
            // log the json response
            //console.log(res.responseText);
            var response = res.responseText;

            // translate response into object
            var responseObject = eval('('+response+')');

            // access elements inside json object with dot notation
            if(responseObject.error && responseObject.error.code == "400"){
                console.debug('we have an error in the response');
                theIpAddress = 'false';
            }else{
                //console.debug('IP is : ' + responseObject.answer[0].rdata.toString());
                theIpAddress = responseObject.answer[0].rdata.toString();
                myFile.write(theIpAddress);
                reloadHosts();

                if(isConfigured){
                    banner2.text = qsTr("The configuration was apply with succes");
                }else{
                    banner2.text = qsTr("The configuration was not apply ! Something is wrong...");
                }
                banner2.show();
                progressbar1.visible = false
                progressbar2.visible = false
            }

        });
    }
}

/**
 * My method description.  Like other pieces of your comment blocks,
 * this can span multiple lines.
 *
 * @method methodName
 * @param {String} foo Argument 1
 * @param {Object} config A config object
 * @param {String} config.name The name on the config object
 * @param {Function} config.callback A callback function on the config object
 * @param {Boolean} [extra=false] Do extra, optional work
 * @return {Boolean} Returns true on success
 */
function request(url, callback) {
    var xhr = new XMLHttpRequest();
    xhr.onreadystatechange = (function(myxhr) {
        return function() {
            if(myxhr.readyState === 4) callback(myxhr);
        }
    })(xhr);
    xhr.open('GET', url, true);
    xhr.send('');
}
