import QtQuick 1.1
import com.nokia.meego 1.1
import com.nokia.extras 1.1
import FileIO 1.0

PageStackWindow {
    id :mainPageStack

    //////////////////////////////////////////////////////////////////////////
    //Custom Property
    //////////////////////////////////////////////////////////////////////////
    property bool isConfigured: false;


    //////////////////////////////////////////////////////////////////////////
    //Open QML File
    //////////////////////////////////////////////////////////////////////////
    function openFile(file) {
        var component = Qt.createComponent(file)
        if (component.status === Component.Ready)
            pageStack.push(component);
        else
            console.log("Erreur lor du chargement de la page", component.errorString());
    }

    //////////////////////////////////////////////////////////////////////////
    //Reload the file
    //////////////////////////////////////////////////////////////////////////
    function reloadHosts() {
        //console.log('/////////////function reloadHosts()///////////////////')
        myFile.read();
        if(myFile.existInHostFile){
            isConfigured = true
        }else{
           isConfigured = false
        }
        //console.log('myFile.existInHostFile : ' + myFile.existInHostFile)
        //console.log('------------function reloadHosts()----------------')
    }

    //////////////////////////////////////////////////////////////////////////
    //The main page
    //////////////////////////////////////////////////////////////////////////
    MainPage {
        id: mainPage
    }

    initialPage: mainPage

    FileIO {
        id: myFile
        source: "/etc/hosts"
        onError: console.log(msg)
        onSourceChanged: {
            //console.log("Source have change");
            myFile.read();
            if(myFile.existInHostFile){
                isConfigured = true
            }else{
               isConfigured = false
            }
        }
    }

    Component.onCompleted: {
        myFile.read();
        if(myFile.existInHostFile)
            isConfigured = true
    }

    ToolBarLayout {
        id: commonTools

        ToolIcon {
            platformIconId: "toolbar-view-menu"
            anchors.right: (parent === undefined) ? undefined : parent.right
            onClicked: (myMenu.status === DialogStatus.Closed) ? myMenu.open() : myMenu.close()
        }

        ToolIcon{
            property bool active: false
            id: home
            iconId: "icon-m-content-invitation-pending"
            onClicked:{
                if(home.active == true){
                    openFile('MainPage.qml');
                    home.active = false
                    fixIt.active = true
                }
            }
        }

        ToolIcon{
            property bool active: true
            id: fixIt
            iconId: "icon-m-common-done"
            onClicked: {
                if(fixIt.active == true){
                    openFile('FixItPage.qml');
                    fixIt.active = false
                    home.active = true
                }
            }
        }

        anchors {
            horizontalCenter: parent.horizontalCenter
            topMargin: 10
        }

        ToolIcon {
            platformIconId: "toolbar-previous"
            anchors.left: (parent === undefined) ? undefined : parent.left
            onClicked: {
                if(pageStack.depth <= 1){
                    Qt.quit();
                }else{
                    pageStack.pop();
                    fixIt.active = true
                    home.active = true
                    home.visible = true
                    fixIt.visible = true
                    //console.log(pageStack.currentPage)
                }
            }
        }
    }

    Menu {
        visible: true
        id: myMenu
        visualParent: pageStack
        MenuLayout {
            MenuItem{
                text: qsTr("T.M.O Thread")
                onClicked: Qt.openUrlExternally("http://talk.maemo.org/showthread.php?t=95777")
            }
            MenuItem {
                text: qsTr("About")
                onClicked: pageStack.push(Qt.createComponent('AboutPage.qml'))
            }

            MenuItem {
                text: qsTr("Quit")
                onClicked: Qt.quit()
            }

        }

    }
}
